# Weechat-Chatwork

正社員として働いている会社でチャットワークを使っていますが、毎回ブラウザで開く事が面倒くさいですので、Weechatのプラグインを作ってみました。

## 従属ソフト

* weechat
* curl
* cjson

### ☺️ Artix/Arch/Manjaro

```sh
doas pacman -S weechat libcurl cjson
```

### ☺️ CRUX

[contrib](https://crux.nu/portdb/?a=repo&q=contrib)と[suwaports](https://crux.nu/portdb/?a=repo&q=suwaports)のレポジトリを有効にして下さい。\
`curl`はきっとインストール済みです。

```sh
doas ports -u
doas prt-get depinst weechat cjson
```

### 🤨 OpenBSD

WeeChatは古い版ため、手動でコンパイルする事が必要となります。

```sh
doas su
cd /usr/ports
cvs -q up -Pd -A
cd net/weechat
make install
exit
doas pkg_add curl cjson
```

### ☺️ FreeBSD

```sh
doas pkg install weechat curl cjson
```

### 🤡 Devuan/Debian/Ubuntu/Linux Mint

WeeChatは古い版ため、手動でAPTを設定する事が必要となります。

```sh
doas su
apt install ca-certificates dirmngr gpg-agent apt-transport-https
mkdir /root/.gnupg
chmod 700 /root/.gnupg
mkdir -p /usr/share/keyrings
gpg --no-default-keyring --keyring /usr/share/keyrings/weechat-archive-keyring.gpg --keyserver hkps://keys.openpgp.org --recv-keys 11E9DE8848F2B65222AA75B8D1820DB22A11534E
echo "deb [signed-by=/usr/share/keyrings/weechat-archive-keyring.gpg] https://weechat.org/debian bookworm main" > /etc/apt/sources.list.d/weechat.list
apt update
apt install weechat curl libcurl4 libcjson1
```

## インストールする方法

### Linux（weechatは/usr/binにある場合）、OpenIndiana、Haiku

```sh
make
doas make install
```

### FreeBSDとOpenBSD、Linux（weechatは/usr/local/binにある場合）

```sh
make
doas make PREFIX=/usr/local install
```

### NetBSD

```sh
make
doas make PREFIX=/usr/pkg install
```
